/*--------------------------------------------------------------------.
| menu_bframe.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

static char rcsid[] = "$Id$";

/*
 * $Log$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

static long ASWAKE (WM_wwork_t *, WM_litm_t *, WM_wstat_t *, 
		    short, short, short, short);

static struct WM_action aswake = {JSR, wm_actli, ASWAKE};
extern long lit_reset (WM_wwork_t *, short);

#define TI_MAX 24

static QD_TEXT (TI_MAX) _title = {0};
static WM_wstat_t ws = {0};

static struct WM_litm litm[1 + 1] =
{
    {0, 10,		/* xsize, ysize size */
     2, 1,		/* xorg, yorg  and origin */
     0, 0,		/* xjst, yjst justification */
     TYP_TEXT, K_WAKE,	/* type, skey type and select key */
     &_title,		/* *pobj pointer to object */
     0,		        /* item  item number */
     &aswake},		/* *pact pointer to action */
    {-1}			
};

static struct WM_wwork ww =	/* window working definition */
{
    NULL,		/* *wstat;              pointer to status area */
    NULL,		/* *wscale              this was pointer to WDEF */
    0,		/* chid                 channel ID */
    NULL,		/* *pprec               pointer to pointer record */
    0,		/* psave                pointer position saved */
    0, 0, 0, 0,	/* 4 zero */
    NULL,		/* *splst               pointer to sprite list */
    16, 12,		/* xsize, ysize         size */
    0, 0,		/* xorg, yorg           and origin */
    0,		/* flag                 no clear + shadow */
    1, CL_BBORD, CL_MBACK,	/* borw, borc, papr border width/clr, paper */
    NULL,		/* *sprite              pointer to sprite */
    1, CL_MHIGH,	/* curw, curc           current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL, 
    CL_BPAVBL, CL_BIAVBL, NULL, NULL,
    CL_BPSLCT, CL_BISLCT, NULL, NULL, 
    NULL,			/* *help */
    0, 0, NULL,		/* ninfo, ninob, *pinfo info winds */
    1, litm,		/* nlitm, *plitm        loose items */
    0, NULL			/* nappl  *pappl        appl winds */
};

void menu_button (WM_wwork_t *wwk, char *title)
{
    short sleep_wid;

    ws.wwork = &ww;
    ww.wstat = &ws;
    ww.chid = wwk->chid;	
    ww.flag = 0;
    ws.wmode = FORM_QL4;

    _title.len = strlen(title);
    strcpy((char *)_title.chrs, title);

    sleep_wid = (((_title.len * 6) + 3) & 0xfffc); 

    ww.xsize = sleep_wid + 4;	
    ww.xorg = sleep_wid - 4;	
    ww.yorg = 9;

    litm[0].xsize = sleep_wid;	

    ws.litem[0] = ws.litem[1] = 0;
    ws.citem = -1;		
    ws.ciact = NULL;		
    wm_unset (wwk);		

    if (bt_prpos (&ww))
    {
	ww.flag = 2;		
	wm_prpos (&ww, DEFXY);
    }
    wm_wdraw (&ww);
    while (!wm_rptr (&ww))
    {
        if ((ws.evnt & PT_WAKE))
            break;
    }

    wm_unset (&ww);  

    if (!ww.flag)
    {
	bt_free ();
    }

    wwk->xorg = wwk->wstat->ptpsx - wwk->xorg;
    wwk->yorg = wwk->wstat->ptpsy - wwk->yorg;
    wm_prpos (wwk, wwk->wstat->ptpsx, wwk->wstat->ptpsy);
    wm_wdraw (wwk);	
}

static long ASWAKE (WM_wwork_t *wwk, WM_litm_t *li, WM_wstat_t *wst, 
		    short xpos, short ypos, short key, short event)
{
    if (event)
    {
	return PT__WAKE;     
    }
    else if (wwk->flag)
    {
        short dx,dy;
        wwk->wstat->evnt |= PT_WMOVE;  
        wm_chwin (wwk, &dx, &dy);	
        sd_setin(wwk->chid, -1, 0);
        sd_setst(wwk->chid, -1, 7);
    }
   return lit_reset (wwk, 0);
}



